import { openBlock as l, createElementBlock as s, createElementVNode as a, toDisplayString as d, renderSlot as _, ref as A, computed as y, normalizeClass as B, createVNode as M, withCtx as $, useSlots as O, createCommentVNode as c, unref as T, resolveComponent as D, Fragment as w, renderList as V, createBlock as k, createTextVNode as L, inject as I, withDirectives as z, vModelDynamic as P, provide as U, watch as K, resolveDynamicComponent as F, normalizeStyle as ee, vModelCheckbox as H, onMounted as E, withKeys as R, withModifiers as N, vModelSelect as te } from "vue";
import le from "fuse.js";
import { getProperty as j } from "dot-prop";
import { RouterLink as Z } from "vue-router";
const se = {
  key: 0,
  class: "cf-action-card"
}, oe = { class: "cf-action-card__body" }, ne = { class: "cf-action-card__title" }, ae = { class: "cf-action-card__body__slot" }, re = { class: "cf-action-card__action" }, ie = {
  key: 1,
  class: "cf-simple-action-card"
}, Fl = {
  __name: "ActionCard",
  props: {
    title: String,
    simple: Boolean
  },
  setup(o) {
    const t = o;
    return (e, n) => t.simple ? (l(), s("div", ie, [
      a("div", null, [
        _(e.$slots, "body")
      ]),
      a("div", null, [
        _(e.$slots, "action")
      ])
    ])) : (l(), s("div", se, [
      a("div", oe, [
        a("div", ne, d(t.title), 1),
        a("div", ae, [
          _(e.$slots, "body")
        ])
      ]),
      a("div", re, [
        _(e.$slots, "action")
      ])
    ]));
  }
};
const G = (o, t) => {
  const e = o.__vccOpts || o;
  for (const [n, r] of t)
    e[n] = r;
  return e;
}, ue = {}, de = { class: "cf-app-bar" };
function ce(o, t) {
  return l(), s("header", de, [
    a("div", null, [
      _(o.$slots, "left")
    ]),
    a("div", null, [
      _(o.$slots, "right")
    ])
  ]);
}
const _e = /* @__PURE__ */ G(ue, [["render", ce]]);
const pe = { class: "cf-dropdown-body" }, fe = {
  __name: "Dropdown",
  setup(o) {
    const t = A(!1), e = y(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (n, r) => (l(), s("div", {
      class: B(e.value)
    }, [
      a("div", {
        class: "cf-dropdown-toggle",
        onClick: r[0] || (r[0] = (i) => t.value = !t.value)
      }, [
        _(n.$slots, "toggle")
      ]),
      a("div", pe, [
        _(n.$slots, "body")
      ]),
      a("div", {
        class: "cf-dropdown-backdrop",
        onClick: r[1] || (r[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const ve = {
  key: 0,
  class: "cf-app-bar-link"
}, me = { class: "cf-app-bar-link__label" }, he = /* @__PURE__ */ a("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ a("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), be = {
  key: 1,
  class: "cf-app-bar-link"
}, ye = { class: "cf-app-bar-link__label" }, Ol = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(o) {
    return (t, e) => o.dropdown ? (l(), s("div", ve, [
      M(fe, null, {
        toggle: $(() => [
          a("div", me, [
            _(t.$slots, "default"),
            he
          ])
        ]),
        body: $(() => [
          _(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), s("button", be, [
      a("div", ye, [
        _(t.$slots, "default")
      ])
    ]));
  }
};
const Rl = {
  __name: "AppView",
  props: { wide: Boolean },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (n, r) => (l(), s("div", {
      class: B(e.value)
    }, [
      _(n.$slots, "default")
    ], 2));
  }
};
const ge = { class: "cf-app-view-header" }, $e = { key: 0 }, ke = { key: 1 }, we = { key: 2 }, Se = {
  key: 3,
  class: "cf-app-view-header-actions"
}, jl = {
  __name: "AppViewHeader",
  props: {
    surtitle: String,
    title: String,
    description: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, r) => (l(), s("header", ge, [
      t.surtitle ? (l(), s("p", $e, d(t.surtitle), 1)) : c("", !0),
      t.title ? (l(), s("h1", ke, d(t.title), 1)) : c("", !0),
      t.description ? (l(), s("p", we, d(t.description), 1)) : c("", !0),
      T(e).actions ? (l(), s("div", Se, [
        _(n.$slots, "actions")
      ])) : c("", !0)
    ]));
  }
};
const Il = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (n, r) => (l(), s("div", {
      class: B(e.value)
    }, [
      _(n.$slots, "default")
    ], 2));
  }
};
const xe = { class: "cf-breadcrumbs" }, Ce = { key: 0 }, Ul = {
  __name: "Breadcrumbs",
  props: { data: Array },
  setup(o) {
    const t = o;
    return (e, n) => {
      const r = D("RouterLink");
      return l(), s("ol", xe, [
        (l(!0), s(w, null, V(t.data, (i) => (l(), s("li", {
          key: i.name
        }, [
          i.path ? (l(), k(r, {
            key: 1,
            to: i.path
          }, {
            default: $(() => [
              L(d(i.name), 1)
            ]),
            _: 2
          }, 1032, ["to"])) : (l(), s("span", Ce, d(i.name), 1))
        ]))), 128))
      ]);
    };
  }
}, W = {
  to: {
    type: [String, Object],
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const Ve = ["type", "disabled"], Kl = {
  __name: "FilledButton",
  props: W,
  setup(o) {
    const t = o, e = y(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (n, r) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: B(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          _(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: B(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        _(n.$slots, "default")
      ], 10, Ve));
    };
  }
};
const Be = ["type", "disabled"], Ae = {
  __name: "OutlinedButton",
  props: W,
  setup(o) {
    const t = o, e = y(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (n, r) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: B(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          _(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: B(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        _(n.$slots, "default")
      ], 10, Be));
    };
  }
};
const Le = ["disabled"], Pl = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const r = D("router-link");
      return o.to ? (l(), k(r, {
        key: 0,
        class: "cf-text-button",
        to: o.to,
        inert: t.disabled
      }, {
        default: $(() => [
          _(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), s("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        _(e.$slots, "default")
      ], 8, Le));
    };
  }
};
const qe = { class: "cf-choice" }, Te = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], De = ["for"], Ne = { key: 1 }, Me = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Object, Array],
    value: [Number, String, Boolean, Object],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: [String, Boolean],
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = Math.random(), r = {
      name: I("choice-list-name", null),
      required: I("choice-list-required", null)
    }, i = y({
      get() {
        return e.modelValue;
      },
      set(u) {
        t("update:modelValue", u);
      }
    });
    return (u, f) => (l(), s("div", qe, [
      z(a("input", {
        "onUpdate:modelValue": f[0] || (f[0] = (m) => i.value = m),
        type: e.type,
        id: T(n),
        name: r.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: r.required,
        disabled: e.disabled
      }, null, 8, Te), [
        [P, i.value]
      ]),
      o.label ? (l(), s("label", {
        key: 0,
        for: T(n)
      }, d(e.label || e.value), 9, De)) : c("", !0),
      e.helper ? (l(), s("small", Ne, d(e.helper), 1)) : c("", !0)
    ]));
  }
};
const ze = {
  key: 0,
  class: "cf-choice-list__label"
}, Hl = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = y(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), r = y({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return U("choice-list-name", Math.random()), U("choice-list-required", e.required), (i, u) => (l(), s("div", {
      class: B(n.value)
    }, [
      e.label ? (l(), s("div", ze, d(e.label), 1)) : c("", !0),
      (l(!0), s(w, null, V(o.choices, (f) => (l(), k(Me, {
        key: f.value || f,
        type: e.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: e.disabled,
        modelValue: r.value,
        "onUpdate:modelValue": u[0] || (u[0] = (m) => r.value = m)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      _(i.$slots, "default")
    ], 2));
  }
};
function q(o) {
  return typeof o == "function" ? o() : T(o);
}
function Fe(o, t, e) {
  const n = () => {
    var u, f;
    return new le(
      (u = q(t)) != null ? u : [],
      (f = q(e)) == null ? void 0 : f.fuseOptions
    );
  }, r = A(n());
  K(
    () => {
      var u;
      return (u = q(e)) == null ? void 0 : u.fuseOptions;
    },
    () => {
      r.value = n();
    },
    { deep: !0 }
  ), K(
    () => q(t),
    (u) => {
      r.value.setCollection(u);
    },
    { deep: !0 }
  );
  const i = y(() => {
    const u = q(e);
    if (u != null && u.matchAllWhenSearchEmpty && !q(o))
      return q(t).map((m, S) => ({ item: m, refIndex: S }));
    const f = u == null ? void 0 : u.resultLimit;
    return r.value.search(q(o), f ? { limit: f } : void 0);
  });
  return {
    fuse: r,
    results: i
  };
}
const X = {
  modelValue: [Number, String, Object],
  value: [Number, String, Object],
  label: String,
  disabled: Boolean,
  required: Boolean,
  helper: String,
  title: String,
  autofocus: Boolean
};
const Oe = { class: "cf-form-control" }, Re = { key: 0 }, je = { class: "cf-form-control-widget" }, Ie = { key: 0 }, Ue = ["disabled", "required", "type", "placeholder", "list", "step", "max", "min", "maxlength", "minlength", "pattern", "title", "autofocus"], Ke = { key: 1 }, Pe = { key: 1 }, J = {
  __name: "Input",
  props: {
    type: {
      type: String,
      default: "text"
    },
    placeholder: String,
    prefix: String,
    suffix: String,
    list: String,
    step: [Number, String],
    max: [Number, String],
    min: [Number, String],
    maxlength: [Number, String],
    minlength: [Number, String],
    pattern: String,
    ...X
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = y({
      get: () => e.modelValue || e.value,
      set: (r) => t("update:modelValue", r)
    });
    return (r, i) => (l(), s("div", Oe, [
      e.label ? (l(), s("label", Re, d(e.label), 1)) : c("", !0),
      a("div", je, [
        e.prefix ? (l(), s("div", Ie, d(e.prefix), 1)) : c("", !0),
        z(a("input", {
          "onUpdate:modelValue": i[0] || (i[0] = (u) => n.value = u),
          disabled: e.disabled,
          required: e.required,
          type: e.type,
          placeholder: e.placeholder,
          list: e.list,
          step: e.step,
          max: e.max,
          min: e.min,
          maxlength: e.maxlength,
          minlength: e.minlength,
          pattern: e.pattern,
          title: e.title,
          autofocus: e.autofocus
        }, null, 8, Ue), [
          [P, n.value]
        ]),
        e.suffix ? (l(), s("div", Ke, d(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", Pe, d(e.helper), 1)) : c("", !0)
    ]));
  }
}, He = {
  key: 0,
  class: "cf-data-table-title"
}, Ee = {
  key: 1,
  class: "cf-data-table-description"
}, Ze = {
  key: 2,
  class: "cf-data-table-search"
}, Ge = {
  key: 3,
  class: "cf-data-table-action"
}, We = {
  __name: "DataTableHeader",
  props: {
    title: String,
    description: String,
    searchable: Boolean,
    search: String
  },
  emits: ["update:search"],
  setup(o, { emit: t }) {
    const e = o, n = O(), r = y({
      get: () => e.search,
      set: (i) => t("update:search", i)
    });
    return (i, u) => (l(), s("header", null, [
      e.title ? (l(), s("div", He, d(e.title), 1)) : c("", !0),
      e.description ? (l(), s("div", Ee, d(e.description), 1)) : c("", !0),
      e.searchable ? (l(), s("div", Ze, [
        M(J, {
          modelValue: r.value,
          "onUpdate:modelValue": u[0] || (u[0] = (f) => r.value = f),
          label: "Search"
        }, null, 8, ["modelValue"])
      ])) : c("", !0),
      T(n).default ? (l(), s("div", Ge, [
        _(i.$slots, "default")
      ])) : c("", !0)
    ]));
  }
}, Xe = {
  key: 0,
  "data-table-checkbox": ""
}, Je = ["value", "checked", "disabled"], Qe = {
  key: 1,
  "data-table-row-actions": ""
}, Ye = { key: 0 }, et = {
  __name: "DataTableRow",
  props: {
    data: Object,
    columns: Array,
    forceMenu: Boolean,
    includeCheckbox: Boolean
  },
  emits: ["toggle", "action"],
  setup(o, { emit: t }) {
    const e = o, n = y(() => e.forceMenu || e.data.actions.length > 1), r = y(() => e.data.actions.map((u) => {
      const f = u.name || u, m = u.key || f.toUpperCase().replaceAll(" ", "_"), S = () => t("action", { key: m, data: e.data });
      let h = "button";
      return u.to && (h = Z), u.href && (h = "a"), {
        label: f,
        to: u.to,
        href: u.href,
        key: m,
        invoke: S,
        component: h
      };
    })), i = y(() => n.value ? { component: "button", label: "•••", invoke: null } : r.value[0]);
    return (u, f) => (l(), s("tr", null, [
      e.includeCheckbox ? (l(), s("td", Xe, [
        a("input", {
          type: "checkbox",
          value: e.data.id,
          checked: e.data.selected,
          disabled: !e.data.selectable,
          onChange: f[0] || (f[0] = (m) => t("toggle"))
        }, null, 40, Je)
      ])) : c("", !0),
      _(u.$slots, "default", {}, () => [
        (l(!0), s(w, null, V(e.columns, (m) => {
          var S;
          return l(), s("td", {
            key: m.key
          }, d((S = T(j)(e.data, m.key)) == null ? void 0 : S.toLocaleString()), 1);
        }), 128))
      ]),
      e.data.actions ? (l(), s("td", Qe, [
        (l(), k(F(i.value.component), {
          to: i.value.to,
          href: i.value.href,
          onClick: i.value.invoke
        }, {
          default: $(() => [
            L(d(i.value.label), 1)
          ]),
          _: 1
        }, 8, ["to", "href", "onClick"])),
        n.value ? (l(), s("div", Ye, [
          (l(!0), s(w, null, V(r.value, (m) => (l(), k(F(m.component), {
            key: m.key,
            to: m.to,
            href: m.href,
            onClick: m.invoke
          }, {
            default: $(() => [
              L(d(m.label), 1)
            ]),
            _: 2
          }, 1032, ["to", "href", "onClick"]))), 128))
        ])) : c("", !0)
      ])) : c("", !0)
    ]));
  }
};
const tt = { class: "cf-data-table" }, lt = {
  key: 0,
  style: { "--w": "3rem" }
}, st = {
  key: 1,
  style: { "--w": "4rem" }
}, ot = {
  key: 0,
  "data-table-checkbox": ""
}, nt = ["disabled"], at = ["onClick"], rt = { key: 1 }, it = { key: 1 }, El = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    data: {
      type: Array,
      default: () => []
    },
    columns: {
      type: Array,
      default: () => []
    },
    selection: {
      type: Array,
      default: []
    },
    rowActions: [Boolean, Array],
    forceRowMenu: Boolean,
    customTemplate: Boolean,
    selectable: Boolean,
    sortable: Boolean,
    defaultSortKey: {
      type: String,
      default: ""
    },
    searchable: Boolean
  },
  emits: ["update:selection", "row-action"],
  setup(o, { emit: t }) {
    const e = o, n = O(), r = A(e.defaultSortKey), i = A("asc"), u = A(""), f = y(() => {
      if (e.searchable) {
        const { results: b } = Fe(u, e.data, {
          fuseOptions: {
            keys: e.columns.map(({ key: g }) => g),
            minMatchCharLength: 2,
            threshold: 0.15
          },
          matchAllWhenSearchEmpty: !0
        });
        return b.value;
      } else
        return e.data;
    }), m = y(() => f.value.map((b) => b.item || b).sort((b, g) => {
      const v = j(b, r.value), C = j(g, r.value);
      return typeof v == "string" ? i.value === "asc" ? v == null ? void 0 : v.localeCompare(C) : C == null ? void 0 : C.localeCompare(v) : i.value === "asc" ? v - C : C - v;
    }).map((b, g) => {
      const v = b.selectable ?? !0, C = e.selection.includes(b.id), Y = b.actions ?? e.rowActions;
      return {
        ...b,
        index: g,
        selectable: v,
        selected: C,
        actions: Y
      };
    })), S = y(() => m.value.some((b) => b.selectable)), h = y({
      get: () => {
        const b = m.value.filter((g) => g.selectable).length;
        return b >= 1 && b === e.selection.length;
      },
      set: (b) => {
        let g = [];
        b === !0 && (g = m.value.filter((v) => !v.disabled && v.selectable).map((v) => v.id)), t("update:selection", g);
      }
    }), p = (b) => {
      const g = e.selection.includes(b) ? e.selection.slice().filter((v) => v !== b) : e.selection.concat(b);
      t("update:selection", g);
    }, x = (b) => {
      r.value === b ? i.value = i.value === "asc" ? "desc" : "asc" : (r.value = b, i.value = "asc");
    };
    return (b, g) => (l(), s("div", tt, [
      e.title || e.description || e.searchable || T(n).header ? (l(), k(We, {
        key: 0,
        search: u.value,
        "onUpdate:search": g[0] || (g[0] = (v) => u.value = v),
        title: e.title,
        description: e.description,
        searchable: e.searchable
      }, {
        default: $(() => [
          _(b.$slots, "header")
        ]),
        _: 3
      }, 8, ["search", "title", "description", "searchable"])) : c("", !0),
      a("table", null, [
        a("colgroup", null, [
          e.selectable ? (l(), s("col", lt)) : c("", !0),
          (l(!0), s(w, null, V(e.columns, (v) => (l(), s("col", {
            key: v.key,
            style: ee({ "--w": v.width })
          }, null, 4))), 128)),
          e.rowActions ? (l(), s("col", st)) : c("", !0)
        ]),
        a("thead", null, [
          a("tr", null, [
            e.selectable ? (l(), s("th", ot, [
              z(a("input", {
                "onUpdate:modelValue": g[1] || (g[1] = (v) => h.value = v),
                type: "checkbox",
                disabled: !S.value
              }, null, 8, nt), [
                [H, h.value]
              ])
            ])) : c("", !0),
            (l(!0), s(w, null, V(e.columns, (v) => (l(), s("th", {
              key: v.key
            }, [
              e.sortable ? (l(), s("button", {
                key: 0,
                onClick: (C) => x(v.key)
              }, d(v.label), 9, at)) : (l(), s("div", rt, d(v.label), 1))
            ]))), 128)),
            e.rowActions ? (l(), s("th", it)) : c("", !0)
          ])
        ]),
        a("tbody", null, [
          (l(!0), s(w, null, V(m.value, (v) => (l(), k(et, {
            key: v.id,
            data: v,
            columns: e.columns,
            "include-checkbox": e.selectable,
            "force-menu": e.forceRowMenu,
            onToggle: (C) => p(v.id),
            onAction: g[2] || (g[2] = (C) => t("row-action", C))
          }, {
            default: $(() => [
              _(b.$slots, "row", { data: v })
            ]),
            _: 2
          }, 1032, ["data", "columns", "include-checkbox", "force-menu", "onToggle"]))), 128))
        ])
      ])
    ]));
  }
};
const ut = { class: "cf-sidebar-nav" }, dt = /* @__PURE__ */ a("hr", null, null, -1), ct = /* @__PURE__ */ a("span", { class: "material-symbols-outlined" }, null, -1), _t = /* @__PURE__ */ a("span", null, "Collapse sidebar", -1), pt = [
  ct,
  _t
], ft = {
  __name: "Sidebar",
  setup(o) {
    const t = A(!1), e = y(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (n, r) => (l(), s("aside", {
      class: B(e.value)
    }, [
      a("nav", ut, [
        _(n.$slots, "default"),
        dt
      ]),
      a("button", {
        class: "cf-sidebar-toggle",
        onClick: r[0] || (r[0] = (i) => t.value = !t.value)
      }, pt)
    ], 2));
  }
};
const Zl = {
  __name: "AppLayout",
  setup(o) {
    return E(() => {
      document.body.dataset.layout = "app";
    }), (t, e) => (l(), s(w, null, [
      M(_e, null, {
        left: $(() => [
          _(t.$slots, "brand")
        ]),
        right: $(() => [
          _(t.$slots, "navigation")
        ]),
        _: 3
      }),
      M(ft, null, {
        default: $(() => [
          _(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      a("main", null, [
        _(t.$slots, "main")
      ])
    ], 64));
  }
};
const vt = { class: "cf-dialog-header" }, mt = { class: "cf-dialog__title" }, ht = { key: 0 }, bt = { class: "cf-dialog-body" }, yt = { class: "cf-dialog-footer" }, gt = /* @__PURE__ */ a("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ a("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), $t = [
  gt
], Gl = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const e = o, n = A();
    return E(() => {
      n.value.showModal(), n.value.addEventListener("close", () => t("close"));
    }), (r, i) => (l(), s("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: n,
      onKeydown: i[1] || (i[1] = R(N(() => {
      }, ["prevent"]), ["esc"]))
    }, [
      a("div", vt, [
        a("div", mt, d(e.title), 1),
        e.description ? (l(), s("div", ht, d(e.description), 1)) : c("", !0)
      ]),
      a("div", bt, [
        _(r.$slots, "body")
      ]),
      a("div", yt, [
        _(r.$slots, "footer")
      ]),
      a("button", {
        class: "cf-dialog-close",
        onClick: i[0] || (i[0] = (u) => t("close"))
      }, $t)
    ], 544));
  }
};
const kt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, wt = { class: "material-symbols-outlined" }, St = { class: "cf-dropdown-item__label" }, xt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Ct = { class: "material-symbols-outlined" }, Vt = { class: "cf-dropdown-item__label" }, Wl = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (n, r) => {
      const i = D("router-link");
      return o.to ? (l(), k(i, {
        key: 1,
        class: B(e.value),
        to: o.to
      }, {
        default: $(() => [
          o.icon ? (l(), s("div", xt, [
            a("span", Ct, d(o.icon), 1)
          ])) : c("", !0),
          a("div", Vt, [
            _(n.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (l(), s("button", {
        key: 0,
        class: B(e.value)
      }, [
        o.icon ? (l(), s("div", kt, [
          a("span", wt, d(o.icon), 1)
        ])) : c("", !0),
        a("div", St, [
          _(n.$slots, "default")
        ])
      ], 2));
    };
  }
};
const Bt = { class: "cf-drop-zone" }, At = ["onDrop"], Lt = { class: "cf-drop-zone-box__label" }, qt = { class: "cf-drop-zone-box__action" }, Tt = /* @__PURE__ */ a("span", null, "select from device", -1), Dt = ["required"], Nt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Mt = {
  key: 1,
  class: "cf-drop-zone-list"
}, zt = /* @__PURE__ */ a("div", { class: "cf-drop-zone-list__header" }, null, -1), Ft = { class: "cf-drop-zone-list__item" }, Ot = /* @__PURE__ */ a("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ a("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Rt = [
  Ot
], Xl = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(o, { emit: t }) {
    const e = o, n = A(null), r = y(() => !!(e.required && !e.modelValue)), i = y(() => {
      if (e.modelValue) {
        const p = (e.modelValue.size / 1048576).toFixed(0), x = (p / 1e3).toFixed(1);
        return p < 100 ? `${p} MB` : `${x} GB`;
      } else
        return "0 MB";
    }), u = (h) => {
      const p = h.target.files[0];
      m(p);
    }, f = (h) => {
      const p = h.dataTransfer.files[0];
      m(p);
    }, m = (h) => {
      const p = parseInt(e.max) * 1048576;
      p && p < h.size ? (n.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", h), t("add", h));
    }, S = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (h, p) => (l(), s("div", Bt, [
      o.modelValue ? (l(), s("div", Mt, [
        zt,
        a("div", Ft, [
          a("div", null, d(e.modelValue.name), 1),
          a("div", null, d(i.value), 1),
          a("button", { onClick: S }, Rt)
        ])
      ])) : (l(), s("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: N(f, ["prevent"]),
        onDragenter: p[0] || (p[0] = N(() => {
        }, ["prevent"])),
        onDragover: p[1] || (p[1] = N(() => {
        }, ["prevent"])),
        onDragleave: p[2] || (p[2] = N(() => {
        }, ["prevent"]))
      }, [
        a("div", Lt, d(e.label), 1),
        a("label", qt, [
          L(" Drag and drop or "),
          Tt,
          a("input", {
            type: "file",
            ref_key: "input",
            ref: n,
            required: r.value,
            onChange: u
          }, null, 40, Dt)
        ]),
        e.max ? (l(), s("div", Nt, " Files larger than " + d(e.max) + " MB cannot be uploaded ", 1)) : c("", !0)
      ], 40, At))
    ]));
  }
};
const jt = { class: "cf-tag" }, It = /* @__PURE__ */ a("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ a("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Ut = [
  It
], Q = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(o, { emit: t }) {
    const e = o;
    return (n, r) => (l(), s("div", jt, [
      a("span", null, [
        _(n.$slots, "default")
      ]),
      e.removable ? (l(), s("button", {
        key: 0,
        onClick: r[0] || (r[0] = (i) => t("remove"))
      }, Ut)) : c("", !0)
    ]));
  }
};
const Kt = { class: "cf-file-picker" }, Pt = {
  key: 0,
  class: "cf-file-picker-label"
}, Ht = {
  key: 1,
  class: "cf-button cf-file-picker-button"
}, Et = ["required"], Jl = {
  __name: "FilePicker",
  props: {
    modelValue: File,
    label: String,
    action: {
      type: String,
      default: "Choose file"
    },
    required: Boolean
  },
  emits: ["update:modelValue", "change"],
  setup(o, { emit: t }) {
    const e = o, n = (i) => {
      t("update:modelValue", i.target.files[0]), t("change", i);
    }, r = () => {
      t("update:modelValue", null);
    };
    return (i, u) => (l(), s("div", Kt, [
      e.label ? (l(), s("div", Pt, d(e.label), 1)) : c("", !0),
      e.modelValue ? (l(), k(Q, {
        key: 2,
        onRemove: r
      }, {
        default: $(() => {
          var f;
          return [
            L(d((f = e.modelValue) == null ? void 0 : f.name), 1)
          ];
        }),
        _: 1
      })) : (l(), s("label", Ht, [
        L(d(e.action) + " ", 1),
        a("input", {
          type: "file",
          onChange: n,
          required: o.required
        }, null, 40, Et)
      ]))
    ]));
  }
};
const Zt = { class: "cf-header" }, Gt = { key: 0 }, Wt = { key: 1 }, Xt = { key: 0 }, Ql = {
  __name: "Header",
  props: {
    size: {
      type: String,
      default: "h4"
    },
    title: String,
    surtitle: String,
    subtitle: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, r) => (l(), s("div", Zt, [
      a("div", null, [
        t.surtitle ? (l(), s("p", Gt, d(t.surtitle), 1)) : c("", !0),
        (l(), k(F(t.size), null, {
          default: $(() => [
            L(d(t.title), 1)
          ]),
          _: 1
        })),
        t.subtitle ? (l(), s("p", Wt, d(t.subtitle), 1)) : c("", !0)
      ]),
      T(e).action ? (l(), s("div", Xt, [
        _(n.$slots, "action")
      ])) : c("", !0)
    ]));
  }
};
const Jt = ["value", "max"], Yl = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, d(o.value) + "% ", 9, Jt));
  }
};
const Qt = { class: "cf-form-control" }, Yt = { key: 0 }, el = { class: "cf-form-control-widget" }, tl = { key: 0 }, ll = ["disabled", "required", "title", "autofocus"], sl = {
  key: 0,
  value: null
}, ol = ["value", "disabled"], nl = { key: 1 }, al = { key: 1 }, rl = {
  __name: "Select",
  props: {
    options: Array,
    ...X
  },
  emits: ["update:modelValue", "input"],
  setup(o, { emit: t }) {
    const e = o, n = y({
      get: () => e.modelValue || e.value,
      set: (r) => {
        t("update:modelValue", r), t("input", { data: r });
      }
    });
    return (r, i) => (l(), s("div", Qt, [
      e.label ? (l(), s("label", Yt, d(e.label), 1)) : c("", !0),
      a("div", el, [
        e.prefix ? (l(), s("div", tl, d(e.prefix), 1)) : c("", !0),
        z(a("select", {
          "onUpdate:modelValue": i[0] || (i[0] = (u) => n.value = u),
          disabled: e.disabled,
          required: e.required,
          title: e.title,
          autofocus: e.autofocus
        }, [
          !e.required && e.options.length ? (l(), s("option", sl)) : c("", !0),
          (l(!0), s(w, null, V(e.options, (u) => (l(), s("option", {
            key: u.value || u,
            value: u.value || u,
            disabled: u.disabled ?? !1
          }, d(u.label || u), 9, ol))), 128)),
          _(r.$slots, "default")
        ], 8, ll), [
          [te, n.value]
        ]),
        e.suffix ? (l(), s("div", nl, d(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", al, d(e.helper), 1)) : c("", !0)
    ]));
  }
};
const il = { key: 0 }, ul = { class: "material-symbols-outlined" }, dl = {
  key: 1,
  class: "cf-sidebar-link-group"
}, cl = { class: "cf-sidebar-link" }, _l = { class: "material-symbols-outlined" }, pl = { class: "cf-sidebar-link-children" }, es = {
  __name: "SidebarLink",
  props: {
    to: [String, Object],
    href: String,
    icon: String,
    parent: Boolean
  },
  setup(o) {
    const t = o, e = y(() => t.to ? Z : "a");
    return (n, r) => t.parent ? (l(), s("div", dl, [
      a("button", cl, [
        a("figure", null, [
          a("span", _l, d(t.icon), 1)
        ]),
        a("span", null, [
          _(n.$slots, "default")
        ])
      ]),
      a("div", pl, [
        _(n.$slots, "children")
      ])
    ])) : (l(), k(F(e.value), {
      key: 0,
      class: "cf-sidebar-link",
      to: t.to,
      href: t.href
    }, {
      default: $(() => [
        t.icon ? (l(), s("figure", il, [
          a("span", ul, d(t.icon), 1)
        ])) : c("", !0),
        a("span", null, [
          _(n.$slots, "default")
        ])
      ]),
      _: 3
    }, 8, ["to", "href"]));
  }
};
const fl = {}, vl = { class: "cf-spinner" }, ml = /* @__PURE__ */ a("div", null, null, -1), hl = /* @__PURE__ */ a("div", null, null, -1), bl = /* @__PURE__ */ a("div", null, null, -1), yl = /* @__PURE__ */ a("div", null, null, -1), gl = [
  ml,
  hl,
  bl,
  yl
];
function $l(o, t) {
  return l(), s("div", vl, gl);
}
const ts = /* @__PURE__ */ G(fl, [["render", $l]]);
const kl = { class: "cf-summary-list" }, ls = {
  __name: "SummaryList",
  props: {
    data: {
      type: Array,
      default: () => []
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("dl", kl, [
      (l(!0), s(w, null, V(t.data, (r) => (l(), s(w, null, [
        a("dt", null, d(r.label), 1),
        a("dd", null, d(r.value), 1)
      ], 64))), 256))
    ]));
  }
};
const wl = { class: "cf-switch" }, Sl = ["value", "true-value", "false-value", "disabled"], xl = {
  key: 0,
  class: "cf-switch__label"
}, ss = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = y({
      get() {
        return e.modelValue;
      },
      set(r) {
        t("update:modelValue", r);
      }
    });
    return (r, i) => (l(), s("div", wl, [
      z(a("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (u) => n.value = u),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, Sl), [
        [H, n.value]
      ]),
      e.label ? (l(), s("div", xl, d(e.label), 1)) : c("", !0)
    ]));
  }
};
const Cl = { class: "cf-navigation-tabs" }, os = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const r = D("router-link");
      return l(), s("nav", Cl, [
        a("ul", null, [
          (l(!0), s(w, null, V(t.tabs, (i, u) => (l(), s("li", { key: u }, [
            M(r, {
              to: i.to
            }, {
              default: $(() => [
                L(d(i.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const Vl = ["inert"], Bl = { key: 0 }, Al = { class: "cf-tags-field__input" }, Ll = ["required"], ql = { class: "cf-tags-field__tags" }, Tl = { key: 1 }, ns = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = A(!1), r = A(""), i = y(() => {
      var h;
      return (h = e.options) == null ? void 0 : h.map((p) => ({
        label: p.label || p,
        value: p.value || p
      }));
    }), u = y(() => {
      var h;
      return (h = i.value) == null ? void 0 : h.filter(
        (p) => !e.modelValue.includes(p.value)
      );
    }), f = (h) => i.value.find((p) => p.value === h).label, m = () => {
      if (!r.value || e.disabled)
        return !1;
      const h = e.modelValue;
      h.push(r.value), t("update:modelValue", h), r.value = "", n.value = !1;
    }, S = (h) => {
      if (e.disabled)
        return !1;
      const p = e.modelValue;
      p.splice(h, 1), t("update:modelValue", p);
    };
    return (h, p) => (l(), s("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (l(), s("label", Bl, d(e.label), 1)) : c("", !0),
      a("div", Al, [
        !e.options && n.value ? (l(), k(J, {
          key: 0,
          modelValue: r.value,
          "onUpdate:modelValue": p[0] || (p[0] = (x) => r.value = x),
          prefix: e.prefix,
          onKeydown: R(m, ["enter"]),
          onChange: m,
          required: ""
        }, null, 8, ["modelValue", "prefix", "onKeydown"])) : c("", !0),
        e.options && n.value ? (l(), k(rl, {
          key: 1,
          modelValue: r.value,
          "onUpdate:modelValue": p[1] || (p[1] = (x) => r.value = x),
          options: u.value,
          onKeydown: R(m, ["enter"]),
          onChange: m,
          required: ""
        }, null, 8, ["modelValue", "options", "onKeydown"])) : c("", !0),
        n.value ? c("", !0) : (l(), k(Ae, {
          key: 2,
          color: "blue",
          onClick: p[2] || (p[2] = (x) => n.value = !0)
        }, {
          default: $(() => [
            L(d(e.buttonText), 1)
          ]),
          _: 1
        })),
        a("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, Ll)
      ]),
      a("div", ql, [
        (l(!0), s(w, null, V(e.modelValue, (x, b) => (l(), k(Q, {
          key: x,
          onRemove: (g) => S(b)
        }, {
          default: $(() => [
            L(d(e.prefix) + " " + d(e.options ? f(x) : x), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (l(), s("small", Tl, d(e.helper), 1)) : c("", !0)
    ], 8, Vl));
  }
};
export {
  Fl as CfActionCard,
  _e as CfAppBar,
  Ol as CfAppBarLink,
  Zl as CfAppLayout,
  Rl as CfAppView,
  jl as CfAppViewHeader,
  Il as CfBanner,
  Ul as CfBreadcrumbs,
  Me as CfChoice,
  Hl as CfChoiceList,
  El as CfDataTable,
  Gl as CfDialog,
  Xl as CfDropZone,
  fe as CfDropdown,
  Wl as CfDropdownItem,
  Jl as CfFilePicker,
  Kl as CfFilledButton,
  Ql as CfHeader,
  J as CfInput,
  Ae as CfOutlinedButton,
  Yl as CfProgress,
  rl as CfSelect,
  ft as CfSidebar,
  es as CfSidebarLink,
  ts as CfSpinner,
  ls as CfSummaryList,
  ss as CfSwitch,
  os as CfTabNavigation,
  Q as CfTag,
  ns as CfTagsField,
  Pl as CfTextButton
};
